function d = edge_det(a,thresh)

% edgedetection for modified tetrolet transform

% INPUT
% a - image of size N1 x N2
% thresh - threshold

% OUTPUT
% d - binary array of size N1/4 x N2/4 (0: block with edge, 1: block
% without edge


b1 = conv2(a,[1 -1],'same');
b2 = conv2(a,[1 -1]','same');
c = b1 + b2;
c(:,end) = 0; % add last column
c(end,:) = 0; % add last line
c = circshift(c,[1 0]);
c = circshift(c,[0 1]);

d = conv2(c,ones(4), 'valid');
d = d(1:4:end,1:4:end);
d = (abs(d) > thresh);

d = ones(size(d))-d;

